﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WpfCosa
{
    class Effector
    {
        private Boolean started = false;
        private Boolean running = false;

        public Effector()
            : base()
        {
            start();
        }

        public void run(Int32 currentTick, List<DataValue> values)
        {
            if (running) return;

            running = true;
            Boolean readyToStop = doAction(currentTick, values);
            running = false;

            if (readyToStop)
            {
                stop();
            }
        }

        public Boolean isStarted()
        {
            return started;
        }

        public Boolean isStopped()
        {
            return !started;
        }

        public Boolean isRunning()
        {
            return running;
        }

        protected virtual void start()
        {
            started = true;
        }

        protected virtual void stop()
        {
            started = false;
        }

        protected virtual Boolean doAction(Int32 currentTick, List<DataValue> values)
        {
            Console.WriteLine("Action performed!");
            return true;
        }
    }
}
