﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WpfCosa
{
    class Parser
    {
        private StringBuilder buffer = null;

        // strips quotes from a value
        static public String stripQuotes(String sourceString)
        {
            return sourceString.Substring(1, sourceString.Length - 2);
        }

        // constructs a new parser with the line to parse
        public Parser(String line)
            : base()
        {
            if (line == null) line = "";
            buffer = new StringBuilder(line);
        }

        // returns the next token.  The initial buffer modified such 
        // that the new token does not exist in the buffer.
        public String nextToken()
        {
            String token = "";
            if (buffer.Length == 0)
            {
                return "";
            }

            // if text token is a text token, capture all the text between the quotes
            int pos = 0;
            if (buffer.ToString().StartsWith("\""))
            {
                pos = buffer.ToString().IndexOf("\"", 1) + 1;
            }
            else // go to next "space"
            {
                pos = buffer.ToString().IndexOf(" ");
            }

            if (pos < 0)
            {
                pos = buffer.Length;
            }

            token = buffer.ToString().Substring(0, pos);
            buffer.Remove(0, pos);

            // trim the result
            String result = buffer.ToString().Trim();
            buffer.Remove(0, buffer.Length);
            buffer.Append(result);

            return token;
        }

        // returns the remaining content in the parser
        public String getContent()
        {
            return buffer.ToString();
        }
    }
}
